function feature_reliability = compute_feature_reliability(xlf,filter_model_f,feature_info,output_sz,k1,block_inds,num_feature_blocks,feature_reliability)
scores_fs_hc = cell(1,1,num_feature_blocks);
response_hc = cell(1,1,num_feature_blocks);
feature_reliability_new = zeros(num_feature_blocks,1);
        for k = [k1 block_inds]
                if feature_info.feature_is_deep(k) == 0
                    scores_fs_hc{k} = gather(sum(bsxfun(@times, conj(filter_model_f{k}), xlf{k}), 3));
                    scores_fs_hc{k} = resizeDFT2(scores_fs_hc{k}, output_sz);
                    response_hc{k} = ifft2(scores_fs_hc{k}, 'symmetric');
                    feature_reliability_new(k)= max(max(response_hc{k}));
                end
        end
        feature_reliability_new = feature_reliability_new/sum(feature_reliability_new);
        if ~any(feature_reliability)
             feature_reliability = feature_reliability_new;
        else
               feature_reliability = (1-0.025).*feature_reliability + 0.025.*feature_reliability_new;
               feature_reliability = feature_reliability/sum(feature_reliability);
        end

end