function [filter_model_f, spatial_selection, channel_selection] = train_filter(xlf,xlf_pre, feature_info, yf, seq, params, filter_model_f)

if seq.frame == 1
    filter_model_f = cell(size(xlf));
    channel_selection = cell(size(xlf));
    spatial_selection = params.mask_window;
end

for k = 1: numel(xlf)
    model_xf = gather(xlf{k});
    model_xf_pre = gather(xlf_pre{k});
    % ʼ
    if (seq.frame == 1)
        filter_model_f{k} = zeros(size(model_xf));
        lambda3 = 1e-3;% ӽ0
        iter_max = 3;
        mu_max = 20;
        rst= 1;
        lambda3 = lambda3 * rst;
    else
        lambda3 = params.lambda3(feature_info.feature_is_deep(k)+1);
        iter_max = 2;
        mu_max = 0.1;
        dx = model_xf_pre-model_xf;
        rst3= max(0.1,exp(-0.5*mean(conj(dx) .* dx, 3)));
 
        rst = mean(mean(rst3));
        lambda3 = lambda3 *(1 + rst/10);
  %      model_xf_pre{k} =(1 - learning_rate)*model_xf_pre{k}+learning_rate*model_xf;
    end
%           display(['feature layer :' num2str(k) '   exponent :  ' num2str(rst) ',   lamda3:   ' num2str(lambda3)]);

    filter_f = single(zeros(size(model_xf)));% º˲ģ
    filter_prime_f = filter_f; 
    gamma_f = single(zeros(size(model_xf)));
    mu  = 1;

    
    T = feature_info.data_sz(k)^2;% N^2 [39^2,....]
    S_xx = sum(conj(model_xf) .* model_xf, 3);
    Sfilter_pre_f = sum(conj(model_xf) .* filter_model_f{k}, 3);
    Sfx_pre_f = bsxfun(@times, model_xf, Sfilter_pre_f);
    % >
    
    iter = 1;
    while (iter <= iter_max)
        
        % ˲
       
        D = S_xx + T * (mu + lambda3);
        Spx_f = sum(conj(model_xf) .* filter_prime_f, 3);
        Sgx_f = sum(conj(model_xf) .* gamma_f, 3);
        
        filter_f = ((1/(T*(mu + lambda3)) * bsxfun(@times,  yf{k}, model_xf)) - ((1/(mu + lambda3)) * gamma_f) +(mu/(mu + lambda3)) * filter_prime_f) + (lambda3/(mu + lambda3)) * filter_model_f{k} - ...
            bsxfun(@rdivide,(1/(T*(mu + lambda3)) * bsxfun(@times, model_xf, (S_xx .*  yf{k})) + (lambda3/(mu + lambda3)) * Sfx_pre_f - ...
            (1/(mu + lambda3))* (bsxfun(@times, model_xf, Sgx_f)) +(mu/(mu + lambda3))* (bsxfun(@times, model_xf, Spx_f))), D);
        % filter_model_f Ϊһ֡˲ģ
        
        if iter == iter_max && seq.frame > 1
            break;
        end
        
        %ɳڱ
        pmu = ifft2((mu * filter_f+ gamma_f), 'symmetric');
        
        if (seq.frame == 1)
            filter_prime = zeros(size(pmu));
            channel_selection{k} = ones(size(pmu));
            for i = 1:size(pmu,3)
                filter_prime(:,:,i) = spatial_selection{k} .* pmu(:,:,i);
            end
        else
            filter_prime = pmu;
            if feature_info.feature_is_deep(k)
                channel_selection{k} = max(0, mu-params.lambda1./(numel(pmu)*10*sqrt(sum(sum(filter_prime.^2,1),2))));
                [~,b] = sort(channel_selection{k}(:),'descend');
                if numel(b)>1
                    channel_selection{k}(b(ceil(params.channel_selection_rate(feature_info.feature_is_deep(k)+1)*numel(b)):end)) = 0;
                end
                filter_prime = repmat(channel_selection{k},size(filter_prime,1),size(filter_prime,2),1) .* filter_prime;
                
                spatial_selection{k} = max(0,mu - params.lambda2./(numel(pmu)*sqrt(sum(filter_prime.^2,3))));
                [~,b] = sort(spatial_selection{k}(:),'descend');
                spatial_selection{k}(b(ceil(params.spatial_selection_rate(feature_info.feature_is_deep(k)+1)*numel(b)+0.5):end)) = 0;
                filter_prime = repmat(spatial_selection{k},1,1,size(filter_prime,3)) .* filter_prime;
            else
                spatial_selection{k} = max(0,mu - params.lambda2./(numel(pmu)*sqrt(sum(filter_prime.^2,3))));
                [~,b] = sort(spatial_selection{k}(:),'descend');
                spatial_selection{k}(b(ceil(params.spatial_selection_rate(feature_info.feature_is_deep(k)+1)*numel(b)):end)) = 0;
                filter_prime = repmat(spatial_selection{k},1,1,size(filter_prime,3)) .* filter_prime;
                
                channel_selection{k} = max(0,mu-params.lambda1./(numel(pmu)*2*sqrt(sum(sum(filter_prime.^2,1),2))));
                [~,b] = sort(channel_selection{k}(:),'descend');
                if numel(b)>1
                    channel_selection{k}(b(ceil(params.channel_selection_rate(feature_info.feature_is_deep(k)+1)*numel(b)+0.5):end)) = 0;
                end
                filter_prime = repmat(channel_selection{k},size(filter_prime,1),size(filter_prime,2),1) .* filter_prime;
            end
        end
        filter_prime_f = fft2(filter_prime);
        % >
        
        
        % <
        gamma_f = gamma_f + (mu * (filter_f - filter_prime_f));
        % >
        
        % ² mu
        % <
        mu = min(1.5 * mu, mu_max);
        % >
        
        iter = iter+1;
    end
    
    % save the trained filters (robustness test)
    %filter_refilter_f{k} = filter_f+randn(size(filter_f))*mean(filter_f(:))*params.stability_factor(feature_info.feature_is_deep(k)+1);

    % <
    if seq.frame == 1
        filter_model_f{k} = filter_f;
    else
        filter_model_f{k} = params.learning_rate(feature_info.feature_is_deep(k)+1)*filter_f ...
            + (1-params.learning_rate(feature_info.feature_is_deep(k)+1))*filter_model_f{k};
    end
    % >
end

end






